package com.systemation.lisa.test.filter;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;

import org.apache.commons.lang3.builder.ReflectionToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import org.apache.log4j.Logger;
import org.w3c.dom.Element;

import com.itko.lisa.test.FilterBaseImpl;
import com.itko.lisa.test.TestDefException;
import com.itko.lisa.test.TestExec;
import com.itko.lisa.test.TestRunException;
import com.itko.util.Parameter;
import com.itko.util.ParameterList;
import com.itko.util.XMLUtils;
import com.mifmif.common.regex.Generex;


public class Test
  extends FilterBaseImpl
{
  private static final long serialVersionUID = 0L;
  private static final Logger logger = Logger.getLogger(Test.class);
  private String prop;
  
  public Test()
  {
    super.setThreadSafe(true);
    if (logger.isDebugEnabled())
    {
      logger.debug("Created Filter: " + getClass().getCanonicalName());
      logger.debug(toString());
    }
  }
  
  public ParameterList getParameters()
  {	  
	    ParameterList localParameterList = new ParameterList();
	    localParameterList.addParameter(new Parameter(PROP_PARAM_DESC, "prop", this.prop, TestExec.PROPERTY_PARAM_TYPE));


    if (logger.isDebugEnabled())
    {
	Iterator<Parameter> localIterator = localParameterList.iterator();
      while (localIterator.hasNext())
      {
        Parameter localParameter = (Parameter)localIterator.next();
        logger.debug("Parameter [name,value] ==> [" + localParameter.getName() + "," + localParameter.getValue() + "]");
        logger.debug(ReflectionToStringBuilder.toString(localParameter));
      }
    }
    return localParameterList;
  }
  
  
  
  
  public boolean subPostFilter(TestExec paramTestExec)
    throws TestRunException
  {
	  
	  try
	    {
		  
		    Object objToString = paramTestExec.getStateValue(this.prop);
		    
		    if ((objToString instanceof String)){
		    	paramTestExec.setStateValue(this.prop, (String)objToString);
		    }

		    return false;
	    }
	    catch (Exception e)
	    {
	    	logger.error(e.getMessage(), e);
	      throw new RuntimeException(e.getMessage(), e);
	    }
	  

  }
  

  
  
  public boolean subPreFilter(TestExec paramTestExec)
  {
    return true;
  }
  
  public void initialize(Element paramElement)
		    throws TestDefException
		  {
		    //super.initialize(paramElement);
		    this.prop = XMLUtils.getAttributeOrChildText(paramElement, "prop");	    
		  }

  
  public String getTypeName()
  {
    return "Test";
  }
  
  public String toString()
  {
    return ReflectionToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
}

